<template>
<v-flex xs12 xl12>
  <v-expand-transition>
    <div>
      <v-card v-show="uuid === ''" class="d-print-none" outlined color="transparent">
        <v-form ref="form" v-model="valid" lazy-validation>

          <!-- Name -->
          <v-text-field
            name="Name"
            v-model="input.Name"
            :rules="nameRules"
            :counter="20"
            label="Ваше имя"
            required
            ></v-text-field>

          <!-- Contact -->
          <v-text-field
            name="Contact"
            v-model="input.Contact"
            :rules="contactRules"
            label="Skype / Телефон / Email"
            required
            ></v-text-field>

          <!-- Desc -->
          <v-textarea
            rows="2"
            name="Desc"
            label="С чем помочь?"
            v-model="input.Desc"
            ></v-textarea>

          <!-- Code -->
          <v-row dense>
            <v-col>
              <v-text-field
                :error-messages="captchaError"
                @input="captchaError = ''"
                name="Code"
                label="Код с картинки"
                v-model="input.CaptchaValue"
                :rules="captchaRules"
                ></v-text-field>
            </v-col>
            <v-col class="col-auto">
              <captcha ref="captcha"></captcha>
            </v-col>
          </v-row>

          <v-alert type="warning" dismissible v-model="showError">{{error}}</v-alert>

          <v-row align="center" justify="center">
            <v-btn
              @click="enroll"
              color="success"
              :loading="loading"
              :disabled="loading || !valid"
              >
              Отправить
              <v-icon right dark>{{ mdiSend }}</v-icon>
            </v-btn>

            <span class="red--text ml-2" v-if="!valid">Заполните форму.</span>
          </v-row>
        </v-form>
      </v-card>
    </div>
  </v-expand-transition>
  <v-expand-transition>
    <v-card v-show="uuid" raised class="pa-3">
      <v-layout v-bind="rowcol">
        <v-icon class="hidden-sm-and-up green--text text-xs-center" size="64">{{mdiAccountCheck}}</v-icon>
        <v-icon class="hidden-xs-only green--text mr-3" size="64">
          {{mdiAccountCheck}}
        </v-icon>
        <div>
          <p class="display-1">Спасибо за обращение!</p>

          Я свяжусь с Вами, когда освобожусь по следующему контакту: <br/>

          <p><b>{{ input.Contact }}</b></p>

          На всякий случай - все мои контакты есть <router-link to="/contacts">тут</router-link>. <br/>

          <v-btn @click="confirm">Ok</v-btn>
        </div>
      </v-layout>
    </v-card>
  </v-expand-transition>
</v-flex>
</template>


<script>
import { API } from 'commonfe';
import { mapState } from 'vuex';
import {
  mdiAccountCheck,
  mdiSend,
} from '@mdi/js';

export default {
  computed: {
    rowcol() {
      const binding = {};
      if (this.$vuetify.breakpoint.xs) {
        binding.column = true;
      }
      return binding;
    },
    ...mapState([
      'app',
      'user',
      'repetitor',
    ]),
  },
  components: {
    captcha: () => import('commonfe/src/Captcha.vue'),
  },
  props: {
    hidePhones: Boolean,
  },
  data: () => ({
    // icons
    mdiSend,
    mdiAccountCheck,

    showError: false,
    error: null,

    incorrectCode: false,
    captchaError: '',
    API,
    uuid: '',
    input: {
      Name: '',
      Contact: '',
      Desc: '',
      CaptchaID: '',
      CaptchaValue: '',
    },

    valid: true,
    loading: false,
    nameRules: [
      (v) => !!v || 'Нужно заполнить Имя',
      // (v) => (v && v.length <= 10) || 'Name must be less than 10 characters',
    ],
    contactRules: [
      (v) => !!v || 'Как с Вами связаться?',
    ],
    captchaRules: [
      (v) => !!v || 'Введите код',
    ],
  }),
  methods: {
    async enroll() {
      // If form is not valid - exit
      if (!this.$refs.form.validate()) {
        return;
      }

      // Display "loading" circle
      this.loading = true;

      // Make a request
      try {
        this.input.CaptchaID = this.$refs.captcha.id;
        const r = await API.POST('/repetitor/enroll', this.input);
        if (r.data.error_code === 'wrong_captcha') {
          this.incorrectCode = true;
          this.captchaError = 'Неправильный код';
          this.$refs.captcha.refresh();
          return;
        }
        this.incorrectCode = false;
        this.uuid = r.data; // setting this will display "FINISHED" dialog
        this.showError = false;

        // yandex metrika goal
        // this.$metrika.reachGoal('new_lead');

        // gtag_report_conversion();
        this.$gtag.event('conversion', {
          send_to: 'AW-862093969/21DKCNKg0osBEJGFipsD',
          value: 100.0,
          currency: 'RUB',
        });

      } catch (e) {
        this.showError = true;
        this.error = e;
      } finally {
        this.loading = false;
      }
    },
    confirm() {
      this.uuid = '';
      this.input.Name = '';
      this.input.Contact = '';
      this.input.CaptchaValue = '';
    },
  },
};
</script>
